#  This file is part of the Palabos library.
#  Copyright (C) 2009-2010 Jonas Latt
#  E-mail contact: jonas@lbmethod.org
#  The most recent release of Palabos can be downloaded at 
#  <http://www.lbmethod.org/palabos/>
# 
#  The library Palabos is free software: you can redistribute it and/or
#  modify it under the terms of the GNU General Public License as
#  published by the Free Software Foundation, either version 3 of the
#  License, or (at your option) any later version.
# 
#  The library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
Wrapper to the Palabos boundary condition objects.
"""

__all__ = ['regularized']

import plb
import mpi4py
import numpy
import ppexcept
import datatype
import util

def regularized():
    return IncompressibleBC('regularizedBC')

class IncompressibleBC:
    def __init__(self, bcName):
        self.bcName = bcName

    def defineVelocityBC(self, blockLattice):
        plbBC = getattr(blockLattice._interface.library, self.bcName)
        plbBC().setVelocityCondition(blockLattice._plb_block, blockLattice._domain)

    def definePressureBC(self, blockLattice):
        plbBC = getattr(blockLattice._interface.library, self.bcName)
        plbBC().setPressureCondition(blockLattice._plb_block, blockLattice._domain)

