class PypalUnknownTypeError(Exception):
    def __init__(self, dtype):
        self.dtype = dtype
    def __str__(self):
        return 'You can\'t create a PyPal object from the following data type: ' + repr(dtype)

class PyPalConstructorError(Exception):
    def __init__(self): pass
    def __str__(self):
        return 'Wrong parameters for creating this object.'

class PyPalArgWrongNumber(Exception):
    def __init__(self, required, received):
        self._required = required
        self._received = received
    def __str__(self):
        if hasattr(self._required, '__iter__'):
            req_str = ''
            for req in self._required_:
                req_str = req_str + str(req) + ' '
            return 'Wrong number of arguments. Expected nbr of arguments is either of'\
                    '%s, but received number is %i.' \
                    % (req_str, self._received)
        else:
            return 'Wrong number of arguments. Expected %i arguments but received %i.' \
                    % (self._required, self._received)


class PyPalOutOfRange(Exception):
    def __init__(self, message):
        self.message = message
    def __str__(self):
        return message
