/*
 * block.i
 */

%module MODULE_NAME;

%{
#define SWIG_FILE_WITH_INIT
%}

%include "PYPAL_ROOT/swig/core/numpy.i"
%init %{
    import_array();
%}

namespace std {
    class exception;
}

namespace plb {

typedef ptrdiff_t plint;
typedef size_t pluint;

namespace IndexOrdering {
    enum OrderingT {forward, backward, memorySaving};
}

}

namespace plb {
    class PlbException;
    class PlbMemoryException;
    class PlbIOException;
    class PlbNetworkException;
    class PlbLogicException;
    class PlbOutOfRangeException;

    struct Box2D;
    struct Box3D;

}

/* Rename namespace global, because "global" is
 * a protected keyword in Python.
 */
%rename plb::global plb_global;

%include "multiDataField.i";
%include "multiBlockGenerator.i";
%include "dataInitializerWrapper.i";
%include "dataAnalysisWrapper.i";
%include "numPyInterface.i";

