/*
 * dataProcessors/dataAnalysisWrapper.i
 */

%{
#include "PYPAL_ROOT/plbWrapper/block/dataAnalysisWrapper2D.h"
#include "PYPAL_ROOT/plbWrapper/block/dataAnalysisWrapper3D.h"
#include "PALABOS_ROOT/src/dataProcessors/ntensorAnalysisWrapper2D.h"
#include "PALABOS_ROOT/src/dataProcessors/ntensorAnalysisWrapper3D.h"
%}


namespace plb {
    %newobject copyConvert;
    %newobject maskedCopyConvert;
    %newobject extractComponent;
    %newobject maskedExtractComponent;
    %newobject computeNorm;
    %newobject maskedComputeNorm;
    %newobject computeNormSqr;
    %newobject maskedComputeNormSqr;
    %newobject computeSymmetricTensorNorm;
    %newobject maskedComputeSymmetricTensorNorm;
    %newobject computeSymmetricTensorNormSqr;
    %newobject maskedComputeSymmetricTensorNormSqr;
    %newobject computeSymmetricTensorTrace;
    %newobject maskedComputeSymmetricTensorTrace;
    %newobject computeVorticity;
    %newobject maskedComputeVorticity;
    %newobject computeBulkVorticity;
    %newobject maskedComputeBulkVorticity;
    %newobject computeStrainRate;
    %newobject maskedComputeStrainRate;
    %newobject computeStrainRate;
    %newobject maskedComputeStrainRate;
    %newobject add;
    %newobject maskedAdd;
    %newobject subtract;
    %newobject maskedSubtract;
    %newobject multiply;
    %newobject maskedMultiply;
    %newobject divide;
    %newobject maskedDivide;
    %newobject toThePower;
    %newobject maskedToThePower;
    %newobject equals;
    %newobject maskedEquals;
    %newobject lessThan;
    %newobject maskedLessThan;
    %newobject lessEqual;
    %newobject maskedLessEqual;
    %newobject greaterThan;
    %newobject maskedGreaterThan;
    %newobject greaterEqual;
    %newobject maskedGreaterEqual;
    %newobject logicalAnd;
    %newobject maskedLogicalAnd;
    %newobject logicalOr;
    %newobject maskedLogicalOr;
    %newobject negate;
    %newobject maskedNegate;
}

%include "PYPAL_ROOT/plbWrapper/block/dataAnalysisWrapper2D.h"
%include "PYPAL_ROOT/plbWrapper/block/dataAnalysisWrapper3D.h"
%include "PALABOS_ROOT/src/dataProcessors/ntensorAnalysisWrapper2D.h"
%include "PALABOS_ROOT/src/dataProcessors/ntensorAnalysisWrapper3D.h"

%apply (PRECOMP_T* INPLACE_ARRAY1, int DIM1) {(PRECOMP_T* result, int size)};
%template(plbAverage) plb::computeAverage<PRECOMP_T>;
%template(plbBoundedAverage) plb::computeBoundedAverage<PRECOMP_T>;
%template(plbMin) plb::computeMin<PRECOMP_T>;
%template(plbMax) plb::computeMax<PRECOMP_T>;
%template(plbCopyConvertInt) plb::copyConvert<PRECOMP_T,int>;
%template(plbCopyConvertFloat) plb::copyConvert<PRECOMP_T,float>;
%template(plbCopyConvertDouble) plb::copyConvert<PRECOMP_T,double>;
%template(plbExtractComponent) plb::extractComponent<PRECOMP_T>;
%template(plbComputeNorm) plb::computeNorm<PRECOMP_T>;
%template(plbComputeNormSqr) plb::computeNormSqr<PRECOMP_T>;
%template(plbComputeSymmetricTensorNorm) plb::computeSymmetricTensorNorm<PRECOMP_T>;
%template(plbComputeSymmetricTensorNormSqr) plb::computeSymmetricTensorNormSqr<PRECOMP_T>;
%template(plbComputeSymmetricTensorTrace) plb::computeSymmetricTensorTrace<PRECOMP_T>;
%template(plbComputeVorticity) plb::computeVorticity<PRECOMP_T>;
%template(plbComputeBulkVorticity) plb::computeBulkVorticity<PRECOMP_T>;
%template(plbComputeStrainRate) plb::computeStrainRate<PRECOMP_T>;
%template(plbComputeBulkStrainRate) plb::computeBulkStrainRate<PRECOMP_T>;
%template(plbUPO_ScalarProduct) plb::compute_UPO_ScalarProduct<PRECOMP_T>;

%template(m_plbAverage) plb::maskedComputeAverage<PRECOMP_T>;
%template(m_plbBoundedAverage) plb::maskedComputeBoundedAverage<PRECOMP_T>;
%template(m_plbMin) plb::maskedComputeMin<PRECOMP_T>;
%template(m_plbMax) plb::maskedComputeMax<PRECOMP_T>;
%template(m_plbCopyConvertInt) plb::maskedCopyConvert<PRECOMP_T,int>;
%template(m_plbCopyConvertFloat) plb::maskedCopyConvert<PRECOMP_T,float>;
%template(m_plbCopyConvertDouble) plb::maskedCopyConvert<PRECOMP_T,double>;
%template(m_plbExtractComponent) plb::maskedExtractComponent<PRECOMP_T>;
%template(m_plbComputeNorm) plb::maskedComputeNorm<PRECOMP_T>;
%template(m_plbComputeNormSqr) plb::maskedComputeNormSqr<PRECOMP_T>;
%template(m_plbComputeSymmetricTensorNorm) plb::maskedComputeSymmetricTensorNorm<PRECOMP_T>;
%template(m_plbComputeSymmetricTensorNormSqr) plb::maskedComputeSymmetricTensorNormSqr<PRECOMP_T>;
%template(m_plbComputeSymmetricTensorTrace) plb::maskedComputeSymmetricTensorTrace<PRECOMP_T>;
%template(m_plbComputeVorticity) plb::maskedComputeVorticity<PRECOMP_T>;
%template(m_plbComputeBulkVorticity) plb::maskedComputeBulkVorticity<PRECOMP_T>;
%template(m_plbComputeStrainRate) plb::maskedComputeStrainRate<PRECOMP_T>;
%template(m_plbComputeBulkStrainRate) plb::maskedComputeBulkStrainRate<PRECOMP_T>;
%template(m_plbUPO_ScalarProduct) plb::masked_compute_UPO_ScalarProduct<PRECOMP_T>;

%apply (PRECOMP_T* IN_ARRAY1, int DIM1) {(PRECOMP_T* alpha, int size)};

%template(iassign)      plb::assignInPlace<PRECOMP_T>;
%template(iadd)         plb::addInPlace<PRECOMP_T>;
%template(add)          plb::add<PRECOMP_T>;
%template(isubtract)    plb::subtractInPlace<PRECOMP_T>;
%template(subtract)     plb::subtract<PRECOMP_T>;
%template(imultiply)    plb::multiplyInPlace<PRECOMP_T>;
%template(multiply)     plb::multiply<PRECOMP_T>;
%template(idivide)      plb::divideInPlace<PRECOMP_T>;
%template(divide)       plb::divide<PRECOMP_T>;
%template(itoThePower)  plb::toThePowerInPlace<PRECOMP_T>;
%template(toThePower)   plb::toThePower<PRECOMP_T>;
%template(equals)       plb::equals<PRECOMP_T>;
%template(lessThan)     plb::lessThan<PRECOMP_T>;
%template(lessEqual)    plb::lessEqual<PRECOMP_T>;
%template(greaterThan)  plb::greaterThan<PRECOMP_T>;
%template(greaterEqual) plb::greaterEqual<PRECOMP_T>;
%template(logicalAnd)   plb::logicalAnd<PRECOMP_T>;
%template(logicalOr)    plb::logicalOr<PRECOMP_T>;
%template(negate)       plb::negate<PRECOMP_T>;

%template(m_iassign)      plb::maskedAssignInPlace<PRECOMP_T>;
%template(m_iadd)         plb::maskedAddInPlace<PRECOMP_T>;
%template(m_add)          plb::maskedAdd<PRECOMP_T>;
%template(m_isubtract)    plb::maskedSubtractInPlace<PRECOMP_T>;
%template(m_subtract)     plb::maskedSubtract<PRECOMP_T>;
%template(m_imultiply)    plb::maskedMultiplyInPlace<PRECOMP_T>;
%template(m_multiply)     plb::maskedMultiply<PRECOMP_T>;
%template(m_idivide)      plb::maskedDivideInPlace<PRECOMP_T>;
%template(m_divide)       plb::maskedDivide<PRECOMP_T>;
%template(m_itoThePower)  plb::maskedToThePowerInPlace<PRECOMP_T>;
%template(m_toThePower)   plb::maskedToThePower<PRECOMP_T>;
%template(m_equals)       plb::maskedEquals<PRECOMP_T>;
%template(m_lessThan)     plb::maskedLessThan<PRECOMP_T>;
%template(m_lessEqual)    plb::maskedLessEqual<PRECOMP_T>;
%template(m_greaterThan)  plb::maskedGreaterThan<PRECOMP_T>;
%template(m_greaterEqual) plb::maskedGreaterEqual<PRECOMP_T>;
%template(m_logicalAnd)   plb::maskedLogicalAnd<PRECOMP_T>;
%template(m_logicalOr)    plb::maskedLogicalOr<PRECOMP_T>;
%template(m_negate)       plb::maskedNegate<PRECOMP_T>;

