/*
 * multiBlock/multiDataField.i
 */

%{
#include "PALABOS_ROOT/src/multiBlock/multiDataField2D.h"
#include "PYPAL_ROOT/plbWrapper/block/multiBlockInfo2D.h"
#include "PALABOS_ROOT/src/multiBlock/multiDataField3D.h"
#include "PYPAL_ROOT/plbWrapper/block/multiBlockInfo3D.h"
%}

namespace plb {

template<typename T>
class MultiNTensorField2D {
public:
    Box2D getBoundingBox() const;
    plint getNdim() const;
    void initialize();
private:
    MultiNTensorField2D();
};

template<typename T>
class MultiNTensorInfo2D {
public:
    MultiNTensorInfo2D(MultiNTensorField2D<T> const& multiBlock);
    plint getNx() const;
    plint getNy() const;
    plint getNumBlocks() const;
    Box2D getSmallestBlock() const;
    Box2D getLargestBlock() const;
    plint getNumAllocatedCells() const;
};

template<typename T>
class MultiNTensorField3D {
public:
    Box3D getBoundingBox() const;
    plint getNdim() const;
    void initialize();
private:
    MultiNTensorField3D();
};

template<typename T>
class MultiNTensorInfo3D {
public:
    MultiNTensorInfo3D(MultiNTensorField3D<T> const& multiBlock);
    plint getNx() const;
    plint getNy() const;
    plint getNz() const;
    plint getNumBlocks() const;
    Box3D getSmallestBlock() const;
    Box3D getLargestBlock() const;
    plint getNumAllocatedCells() const;
};

}  // namespace plb

%template(PlbMultiNTensorField2D) plb::MultiNTensorField2D<PRECOMP_T>;
%template(PlbMultiBlockInfo2D) plb::MultiNTensorInfo2D<PRECOMP_T>;

%template(PlbMultiNTensorField3D) plb::MultiNTensorField3D<PRECOMP_T>;
%template(PlbMultiBlockInfo3D) plb::MultiNTensorInfo3D<PRECOMP_T>;

