/*
 * plbWrapper/numPyInterface.i
 */

%{
#include "PYPAL_ROOT/plbWrapper/block/numPyInterface2D.h"
#include "PYPAL_ROOT/plbWrapper/block/numPyInterface3D.h"
%}

namespace plb {

template<typename T>
class NTensorField2NumPy2D {
public:
    NTensorField2NumPy2D(MultiNTensorField2D<T>& field_);
    NTensorField2NumPy2D(MultiNTensorField2D<T>& field_, Box2D const& domain);
    void execute(T* array, int size);
    int getSize() const;
};

template<typename T>
class NumPy2NTensorField2D {
public:
    NumPy2NTensorField2D(MultiNTensorField2D<T>& field_);
    NumPy2NTensorField2D(MultiNTensorField2D<T>& field_, Box2D const& domain);
    void execute(T* array, int size);
    int getSize() const;
};

template<typename T>
class NTensorField2NumPy3D {
public:
    NTensorField2NumPy3D(MultiNTensorField3D<T>& field_);
    NTensorField2NumPy3D(MultiNTensorField3D<T>& field_, Box3D const& domain);
    void execute(T* array, int size);
    int getSize() const;
};

template<typename T>
class NumPy2NTensorField3D {
public:
    NumPy2NTensorField3D(MultiNTensorField3D<T>& field_);
    NumPy2NTensorField3D(MultiNTensorField3D<T>& field_, Box3D const& domain);
    void execute(T* array, int size);
    int getSize() const;
};

}  // namespace plb

%apply (PRECOMP_T* INPLACE_ARRAY1, int DIM1) {(PRECOMP_T* array, int size)};
%template(NTensorFieldSerializer2D) plb::NTensorField2NumPy2D<PRECOMP_T>;
%clear (PRECOMP_T* array, int size);

%apply (PRECOMP_T* IN_ARRAY1, int DIM1) {(PRECOMP_T* array, int size)};
%template(NTensorFieldUnSerializer2D) plb::NumPy2NTensorField2D<PRECOMP_T>;
%clear (PRECOMP_T* array, int size);

%apply (PRECOMP_T* INPLACE_ARRAY1, int DIM1) {(PRECOMP_T* array, int size)};
%template(NTensorFieldSerializer3D) plb::NTensorField2NumPy3D<PRECOMP_T>;
%clear (PRECOMP_T* array, int size);

%apply (PRECOMP_T* IN_ARRAY1, int DIM1) {(PRECOMP_T* array, int size)};
%template(NTensorFieldUnSerializer3D) plb::NumPy2NTensorField3D<PRECOMP_T>;
%clear (PRECOMP_T* array, int size);

