/*
 * blockLattice2d.i
 */

%module MODULE_NAME;

%{
#define SWIG_FILE_WITH_INIT
%}

%include "PYPAL_ROOT/swig/core/numpy.i"
%init %{
    import_array();
%}

namespace std {
    class exception;
}

namespace plb {

    typedef ptrdiff_t plint;
    typedef size_t pluint;

}

namespace plb {
    template<typename T> class MultiNTensorField2D;
}


namespace plb {
    class PlbException;
    class PlbMemoryException;
    class PlbIOException;
    class PlbNetworkException;
    class PlbLogicException;
    class PlbOutOfRangeException;

    struct Box2D;
}

/* Rename namespace global, because "global" is
 * a protected keyword in Python.
 */
%rename plb::global plb_global;

%include "dynamics.i";
%include "isoThermalDynamics.i";
%include "multiBlockLattice2D.i";
%include "multiBlockGenerator2D.i";
%include "latticeInitializerWrapper2D.i";
%include "numPyInterface2D.i";
%include "latticeAnalysisWrapper2D.i";
%include "boundaryCondition2D.i";

