/*
 * plbWrapper/lattice/bcWrapper2D.i
 */

%{
#include "PYPAL_ROOT/plbWrapper/lattice/bcWrapper2D.h"
%}

namespace plb {

template<typename T, class Descriptor>
class OuterBoxBC {
public:
    void setVelocityCondition( MultiBlockLattice2D<T,Descriptor>& lattice,
                               Box2D domain );
    void setPressureCondition( MultiBlockLattice2D<T,Descriptor>& lattice,
                               Box2D domain );
private:
    OuterBoxBC();  /** Don't allow access to constructor from
                     * Python.
                     */
};

%newobject generateRegularizedBC;
template<typename T, class Descriptor>
OuterBoxBC<T,Descriptor>* generateRegularizedBC();

}


%template(PlbOuterBoxBC) plb::OuterBoxBC<FLOAT_T,plb::descriptors::DESCRIPTOR_2D>;
%template(regularizedBC) plb::generateRegularizedBC<FLOAT_T,plb::descriptors::DESCRIPTOR_2D>;
