/*
 * blockLattice3d.i
 */

%module MODULE_NAME;

%{
#define SWIG_FILE_WITH_INIT
%}

%include "PYPAL_ROOT/swig/core/numpy.i"
%init %{
    import_array();
%}

namespace std {
    class exception;
}

namespace plb {

    typedef ptrdiff_t plint;
    typedef size_t pluint;

}

namespace plb {
    template<typename T> class MultiNTensorField3D;
}


namespace plb {
    class PlbException;
    class PlbMemoryException;
    class PlbIOException;
    class PlbNetworkException;
    class PlbLogicException;
    class PlbOutOfRangeException;

    struct Box3D;
}

/* Rename namespace global, because "global" is
 * a protected keyword in Python.
 */
%rename plb::global plb_global;

%include "dynamics.i";
%include "isoThermalDynamics.i";
%include "multiBlockLattice3D.i";
%include "multiBlockGenerator3D.i";
%include "latticeInitializerWrapper3D.i";
%include "numPyInterface3D.i";
%include "latticeAnalysisWrapper3D.i";
%include "boundaryCondition3D.i";

