/*
 * core.i
 */

%module core;

%include "std_except.i";
%include "std_string.i";
%include "std_vector.i";
%template(StrVector) std::vector<std::string>;
%template(DoubleVector) std::vector<double>; 

/* Rename namespace global, because "global" is
 * a protected keyword in Python.
 */
%rename plb::global plb_global;

%include "numPyIni.i";
%include "globalDefs.i";
%include "runTimeDiagnostics.i";
%template(PlintVector) std::vector<plb::plint>;
%template(PluintVector) std::vector<plb::pluint>;
%include "plbInit.i";
%include "plbTimer.i";
%include "geometry2D.i"
%include "geometry3D.i"
%include "blockStatistics.i"
