/* This file is part of the Palabos library.
 *
 * Copyright (C) 2011 FlowKit Sarl
 * Avenue de Chailly 23
 * 1012 Lausanne, Switzerland
 * E-mail contact: contact@flowkit.com
 *
 * The most recent release of Palabos can be downloaded at 
 * <http://www.palabos.org/>
 *
 * The library Palabos is free software: you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * The library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <cxxabi.h>

using namespace std;

const char* demangle(const char* name) {
    char buf[1024];
    size_t size=1024;
    int status;
    char* res = abi::__cxa_demangle(name,buf, &size, &status);
    return res;
}

int main(int argc, char* argv[0])
{
    if (argc != 2) {
        cout << "Syntax: " << argv[0] << " mangled_name" << endl;
    }
    cout << demangle(argv[1]) << endl;
}
